unit im_QPLifePatternFrm;

(*nULifeAlien code called from nclife
  LifeForm.WindowState := wsNormal; {wsNormal wsMaximized}
  LifeForm.Image1.Width := 391; {391 781}
  LifeForm.Image1.Height := 241; {241 481}
  SetLength(Aa, 156, 96);
  SetLength(Image, 156, 96);
  SetLength(Image78, 78, 48);
  SetLength(TV15696, 156, 96);
  SetLength(Aa, 78, 48);
  SetLength(Image, 78, 48);
  SetLength(TV7848, 78, 48);*)

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Printers,
  jpg,jpeg,pngimage,
  GR32_Image, GR32_Layers,GR32,
  Menus, StdCtrls, Buttons;

type
  TLifePatternForm = class(TForm)
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N3: TMenuItem;
    Print1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    Edit1: TMenuItem;
    BackgroundColor1: TMenuItem;
    Help1: TMenuItem;
    ColorDialog1: TColorDialog;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    ColorPanel: TPanel;
    BackgroundPanel: TPanel;
    ReplacementPanel: TPanel;
    Label3: TLabel;
    ReplacementColor1: TMenuItem;
    ReplacementBtn: TSpeedButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    BPPanel: TPanel;
    Label4: TLabel;
    ScrollBox1: TScrollBox;
    ImgView321: TImage32;
    SaveCountTotals1: TMenuItem;
    N2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Close1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
PROCEDURE PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    procedure ReplacementPanelClick(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure ReplacementBtnClick(Sender: TObject);
    procedure ImgView321MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure BPPanelClick(Sender: TObject);
    procedure SaveCountTotals1Click(Sender: TObject);
  private
    { Private declarations }
    BPReplace, ColorReplace:Boolean;
    BackColor,MouseColor:TColor32;
  public
    { Public declarations }
  end;

var
  LifePatternForm: TLifePatternForm;

implementation
uses im_D5;
{$R *.DFM}

procedure TLifePatternForm.FormCreate(Sender: TObject);
var Bitmap:TBitmap;
begin
  top := LifePatternFormY;
  left := LifePatternFormX;
  Bitmap:=TBitmap.Create;
  Bitmap.Width:=391;
  Bitmap.Height:=241;
  ImgView321.Bitmap.assign(Bitmap);
  BPReplace:=False;
  ColorReplace:=False;
end;

procedure TLifePatternForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  LifePatternFormX := LifePatternForm.left;
  LifePatternFormY := LifePatternForm.top;
end;

procedure TLifePatternForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TLifePatternForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(13300);
end;

procedure TLifePatternForm.Open1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir :=ImagePath;
  if OpenDialog1.Execute then
  begin
    Application.ProcessMessages;
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);  
    ImgView321.Bitmap.LoadFromFile(OpenDialog1.FileName);
    BackgroundPanel.Color :=WinColor(ImgView321.Bitmap.Pixel[0,0]);
        BackColor:= ImgView321.Bitmap.Pixel[0,0];
  end;
end;

procedure TLifePatternForm.Save1Click(Sender: TObject);
begin
  SaveDialog1.InitialDir :=ImagePath;
    SaveDialog1.Filter :='*.bmp';
  if SaveDialog1.Execute then
    ImgView321.Bitmap.Savetofile(ChangeFileExt(SaveDialog1.Filename,'.bmp'));
end;

procedure TLifePatternForm.Print1Click(Sender: TObject);
var
  PrintRect: TRect;
  TempBitmap:TBitmap;
begin
  if PrinterSetupDialog1.Execute {PrintDialog1.Execute} then
  begin
    Application.ProcessMessages;
    { Add code to print current file }
    with Printer do
    begin
      BeginDoc;
      TempBitmap := TBitmap.Create;
      TempBitmap.Assign(ImgView321.Bitmap);
      {Image1.Picture.Bitmap or FBitmap
      Check to see if enlarged print is available}
{      if PrintBigChecked then
      begin}
      If((PageWidth > (ImgView321.Bitmap.Width * 4)) and
        (PageHeight > (ImgView321.Bitmap.Height * 4))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 4)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 4)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 4)) div 2)
          + (ImgView321.Bitmap.Width * 4)),
          (((PageHeight - (ImgView321.Bitmap.Height * 4)) div 2)
          + (ImgView321.Bitmap.Height * 4)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
{        Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end else
      If((PageWidth > (ImgView321.Bitmap.Width * 2)) and
        (PageHeight > (ImgView321.Bitmap.Height * 2))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 2)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 2)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 2)) div 2)
          + (ImgView321.Bitmap.Width * 2)),
          (((PageHeight - (ImgView321.Bitmap.Height * 2)) div 2)
          + (ImgView321.Bitmap.Height * 2)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
        {Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end;
      EndDoc;
      TempBitmap.Free;
    end;
  end;
end;
  // Based on posting to borland.public.delphi.winapi by Rodney E Geraghty,
  // 8/8/97.  Used to print bitmap on any Windows printer.
PROCEDURE TLifePatternForm.PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    VAR
      BitmapHeader:  pBitmapInfo;
      BitmapImage :  POINTER;
      HeaderSize  :  DWORD;
      ImageSize   :  DWORD;
  BEGIN
    GetDIBSizes(Bitmap.Handle, HeaderSize, ImageSize);
    GetMem(BitmapHeader, HeaderSize);
    GetMem(BitmapImage,  ImageSize);
    TRY
      GetDIB(Bitmap.Handle, Bitmap.Palette, BitmapHeader^, BitmapImage^);
      StretchDIBits(Canvas.Handle,
                    DestRect.Left, DestRect.Top,     // Destination Origin
                    DestRect.Right  - DestRect.Left, // Destination Width
                    DestRect.Bottom - DestRect.Top,  // Destination Height
                    0, 0,                            // Source Origin
                    Bitmap.Width, Bitmap.Height,     // Source Width & Height
                    BitmapImage,
                    TBitmapInfo(BitmapHeader^),
                    DIB_RGB_COLORS,
                    SRCCOPY)
    FINALLY
      FreeMem(BitmapHeader);
      FreeMem(BitmapImage)
    END
END {PrintBitmap};

procedure TLifePatternForm.BPPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= BPPanel.Color;
  if ColorDialog1.Execute then
  Begin
  BPPanel.Color := ColorDialog1.Color;
  BPReplace:=True;
  end;
end;

procedure TLifePatternForm.ReplacementPanelClick(Sender: TObject);
begin  {ReplacementPanel}
  ColorDialog1.Color:= ReplacementPanel.Color;
  if ColorDialog1.Execute then
  begin
    ReplacementPanel.Color := ColorDialog1.Color;
    ColorReplace:=True;
  End;
end;

procedure TLifePatternForm.ReplacementBtnClick(Sender: TObject);
var x,y:Integer;
begin
{Replace all color of
ColorPanel.Color    ReplacementPanel.Color }
  For X:= 0 to ImgView321.Width-1 do
  begin
    Application.ProcessMessages;
    LifePatternForm.Caption:= Inttostr(Round(x/ImgView321.Width)*100);
    For Y:= 0 to ImgView321.Height-1 do
    begin
      If ( ColorReplace and(ImgView321.Bitmap.Pixel[x,y]=MouseColor{Color32(ColorPanel.Color)}) ) then
         ImgView321.Bitmap.SetPixelTS(x,y,Color32(ReplacementPanel.Color))
      else
      If (BPReplace and(ImgView321.Bitmap.Pixel[x,y]=BackColor{Color32(BackgroundPanel.Color)}) ) then
         ImgView321.Bitmap.SetPixelTS(x,y,Color32(BPPanel.Color));
    end;
  end;
  LifePatternForm.Caption:='Life Pattern';
end;

procedure TLifePatternForm.ImgView321MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
begin
  ColorPanel.Color:=WinColor(ImgView321.Bitmap.Pixel[x,y]);
  MouseColor:= ImgView321.Bitmap.Pixel[x,y];
end;



procedure TLifePatternForm.SaveCountTotals1Click(Sender: TObject);
begin
{Actually Need to Load a Life file FROM the Pattern Count
 so the data can be filled...
 OR Convert Pixels INTO data}
end;

end.
